require "pp"
require "monkey.rb"

use Rack::Static, :urls => ["/css", "/js", "/images"], :root => "public"

get "/" do
  haml :index
end

post "/" do
  googl = Googl.client("something@example.com", "secret")
  @short_url = googl.shorten(long_url).short_url
  if request.xhr?
    haml :ajax, :layout => false
  else
    haml :index
  end
end

get "/toggle" do
  toggle_mode
  redirect "/"
end

helpers do
  
  def long_url    
    params_copy = params.dup
    params_copy.delete_if do |key, value| 
      value.empty? || key == "base_url" || key == "shortener"
    end
    # FIXME: Kludge, WTF Rack::Utils overwrites params[:base_url]? 
    save_url = params["base_url"]
    query_string = Rack::Utils.build_query(params_copy)
    params["base_url"] = save_url
    base_url + query_string
  end
  
  def base_url
    last_char = params[:base_url].include?("?") ? "&" : "?"
    params[:base_url] + last_char
  end
  
  def mode
    request.cookies["gash_mode"] || "simple"
  end
  
  def advanced_visibility
    "advanced" == mode ? "visible" : "hidden"
  end

  def advanced_toggle_text
    "advanced" == mode ? "<< Hide advanced" : "Show advanced >>"
  end

  def toggle_mode
    if "simple" == mode
      response.set_cookie("gash_mode", "advanced")
    else
      response.set_cookie("gash_mode", "simple")
    end
  end
  
end